function [ flag1 ] = prunik( TR1,TR2,Apoint,innerareas,Aarea,poz,stinici )
%hleda prunik paprsku miriciho z jednoho teziste trojuelnika do druheho,
%kontroluje pritom jestli neprotnul prekazku, ta je zadana souradnicemi
%samostatne
%vyuzito Moller,Trumbore ray triangle intersection method, podle kapitoly
%1.3


%TR1,TR2:trojuhelnik zadany pomoci vrcholu
%innerareas :prekazky
%poz:pokud pocitame vf vnejsi plochy vuci jedne plose prekazky je potreba
    %kotrolovat,jestli se pocita vf pro vnejsi nebo vnitrni plochu prekazky 
    %popsan v kapitole 2.4.2
%flag1==0 neprotina, flag1==1 protina,


%% vypocet teziste
%vypocet teziste,podle kapitoly 2.5.1

% %bez presifrovani Apoint
% cenT1=zeros(1,3);
% cenT1(1)=1/3*(Apoint{findpoint(TR1(1),Apoint),2}+Apoint{findpoint(TR1(2),Apoint),2}+Apoint{findpoint(TR1(3),Apoint),2});
% cenT1(2)=1/3*(Apoint{findpoint(TR1(1),Apoint),3}+Apoint{findpoint(TR1(2),Apoint),3}+Apoint{findpoint(TR1(3),Apoint),3});
% cenT1(3)=1/3*(Apoint{findpoint(TR1(1),Apoint),4}+Apoint{findpoint(TR1(2),Apoint),4}+Apoint{findpoint(TR1(3),Apoint),4});
% 
% cenT2=zeros(1,3);
% cenT2(1)=1/3*(Apoint{findpoint(TR2(1),Apoint),2}+Apoint{findpoint(TR2(2),Apoint),2}+Apoint{findpoint(TR2(3),Apoint),2});
% cenT2(2)=1/3*(Apoint{findpoint(TR2(1),Apoint),3}+Apoint{findpoint(TR2(2),Apoint),3}+Apoint{findpoint(TR2(3),Apoint),3});
% cenT2(3)=1/3*(Apoint{findpoint(TR2(1),Apoint),4}+Apoint{findpoint(TR2(2),Apoint),4}+Apoint{findpoint(TR2(3),Apoint),4});

%s presifrovanim Apoint
cenT1=zeros(1,3);
cenT1(1)=1/3*(Apoint{TR1(1),2}+Apoint{TR1(2),2}+Apoint{TR1(3),2});
cenT1(2)=1/3*(Apoint{TR1(1),3}+Apoint{TR1(2),3}+Apoint{TR1(3),3});
cenT1(3)=1/3*(Apoint{TR1(1),4}+Apoint{TR1(2),4}+Apoint{TR1(3),4});

cenT2=zeros(1,3);
cenT2(1)=1/3*(Apoint{TR2(1),2}+Apoint{TR2(2),2}+Apoint{TR2(3),2});
cenT2(2)=1/3*(Apoint{TR2(1),3}+Apoint{TR2(2),3}+Apoint{TR2(3),3});
cenT2(3)=1/3*(Apoint{TR2(1),4}+Apoint{TR2(2),4}+Apoint{TR2(3),4});

%% Moller-Trumbore aplikovany na vsechny trojuhelniky innerareas

T1T2=[cenT2(1)-cenT1(1) cenT2(2)-cenT1(2) cenT2(3)-cenT1(3)];
dT1T2=norm(T1T2);

flag1=1;
if dT1T2~=0 %tim zamezime vypoctu dvou shodnych trojuhelniku vuci sobe
d=T1T2/dT1T2;       %smer paprsku
epsilon = 0.00000001;  

[m n]=size(Aarea);
k=0;
flag=zeros(1,1);
t=zeros(1,1);

for i=1:length(innerareas)  %potreba ykontrolovat zda neprotina vsechny plochy
    for j=1:n               %vsechnz jejich trojuhelniky
        if isempty(Aarea{innerareas(i),j})==0
            
            k=k+1;
            %e1=v1-v0, e2=v2-v0
            %bez presifrovani
%             e1 = [Apoint{findpoint(Aarea{innerareas(i),j}(4),Apoint),2}-Apoint{findpoint(Aarea{innerareas(i),j}(3),Apoint),2} Apoint{findpoint(Aarea{innerareas(i),j}(4),Apoint),3}-Apoint{findpoint(Aarea{innerareas(i),j}(3),Apoint),3} Apoint{findpoint(Aarea{innerareas(i),j}(4),Apoint),4}-Apoint{findpoint(Aarea{innerareas(i),j}(3),Apoint),4}];
%             e2 = [Apoint{findpoint(Aarea{innerareas(i),j}(5),Apoint),2}-Apoint{findpoint(Aarea{innerareas(i),j}(3),Apoint),2} Apoint{findpoint(Aarea{innerareas(i),j}(5),Apoint),3}-Apoint{findpoint(Aarea{innerareas(i),j}(3),Apoint),3} Apoint{findpoint(Aarea{innerareas(i),j}(5),Apoint),4}-Apoint{findpoint(Aarea{innerareas(i),j}(3),Apoint),4}];
         
           % s presifrovanim Apoint
            e1 = [Apoint{Aarea{innerareas(i),j}(4),2}-Apoint{Aarea{innerareas(i),j}(3),2} Apoint{Aarea{innerareas(i),j}(4),3}-Apoint{Aarea{innerareas(i),j}(3),3} Apoint{Aarea{innerareas(i),j}(4),4}-Apoint{Aarea{innerareas(i),j}(3),4}];
            e2 = [Apoint{Aarea{innerareas(i),j}(5),2}-Apoint{Aarea{innerareas(i),j}(3),2} Apoint{Aarea{innerareas(i),j}(5),3}-Apoint{Aarea{innerareas(i),j}(3),3} Apoint{Aarea{innerareas(i),j}(5),4}-Apoint{Aarea{innerareas(i),j}(3),4}];
            q  = cross(d,e2);
            
            a  = dot(e1,q); % determinant matice M
            
            %bez presifrovani Apoint
%             vo=[Apoint{findpoint(Aarea{innerareas(i),j}(3),Apoint),2} Apoint{findpoint(Aarea{innerareas(i),j}(3),Apoint),3} Apoint{findpoint(Aarea{innerareas(i),j}(3),Apoint),4}];
            %s presifrovanim Apoint
            vo=[Apoint{Aarea{innerareas(i),j}(3),2} Apoint{Aarea{innerareas(i),j}(3),3} Apoint{Aarea{innerareas(i),j}(3),4}];
                     
            f = 1/a;
            %s=pocatek-vrchol v0(v pocatku ss )
            s = cenT1-vo;
            u = f*dot(s,q);
            
            r = cross(s,e1);
            v = f*dot(d,r);
 %% testovani barycentrickych podminek           
            if (a>-epsilon && a<epsilon)
                % paprsek je rvnobezny s normalou plochy, paprsek v
                % nekonecnu
                flag(k) = 0;
                             
            elseif (u<0.0)
                %barycentricke souradnice, prunik mimo trojuelnik
                flag(k) = 0;
              
            elseif (v<0.0 || u+v>1.0)
                flag(k)=0;
                
            else
                
                t(k) = f*dot(e2,r); 
                
                flag(k) = 1;
                
            end
        end
    end
end
%% vyhodnoceni
%kdyz neprotnul ani jednu plochu pak same nuly

if norm(flag)==0         %vf plocha-plocha (kdyz plocha-prekazka pak automatickz jeden prunik)
    flag1=0;
    return;
end


if poz>stinici-1   %vf plocha - prekazka  (kapitola 2.4.2)
    %     moznosti:
    %     1: vidi na sebe primo paprsku nic nestoji v ceste = pocitat
    %     2:paprsek protina jinou plochu
    %     2.1 pocitana plocha prekazky je bliz =pocitat
    %     2.2 pocitana plocha prekazky je dal=nepocitat
    
    t(t<0) = [];     %nutne pri testovani stinici stinici, dojde k pruniku ktery je za a bliz = driv vyhodnoceno nepocitat i kdyz se pocitat ma
    t=sort(t);      %jednotlive vzdalenosti
    
    t(t==0) = [];   %smaze nuly
    
    
    if isempty(t)==0
        if   abs(t(1)-dT1T2)<10^(-15)  %&&length(t)~=1  %pokud se nejkratsi vzdalenost pruniku od teziste TR1 rovna vzdalenosti tezist pak se jedna o vf vuci vnejsi plose pak pocitat
            flag1=0;
            return;
        else
            
            flag1=1;    %vuci vnitrni = nepocitat
            return;
        end
    end
else         %vf plocha-plocha protina prekazku
    
    flag1=1;    %paprsek protina lib. rovinu prakazky, pri pocitani vf vnejsi vs vnejsi, pak stin --> nepocitat
    return;
    
    
end
end
end














